# Class VulkanOffset3D.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanOffset3D.Builder

Enclosing class:
  `VulkanOffset3D`

public static final class VulkanOffset3D.Builder extends Object
Builds instances of type `VulkanOffset3D`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanOffset3D`
  `build()`
  Builds a new `VulkanOffset3D`.
  `final VulkanOffset3D.Builder`
  `from(VulkanOffset3DType instance)`
  Fill a builder with attribute values from the provided `VulkanOffset3DType` instance.
  `final VulkanOffset3D.Builder`
  `setX(int x)`
  Initializes the value for the `x` attribute.
  `final VulkanOffset3D.Builder`
  `setY(int y)`
  Initializes the value for the `y` attribute.
  `final VulkanOffset3D.Builder`
  `setZ(int z)`
  Initializes the value for the `z` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanOffset3D.Builder from(VulkanOffset3DType instance)
    Fill a builder with attribute values from the provided `VulkanOffset3DType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final VulkanOffset3D.Builder setX(int x)
    Initializes the value for the `x` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `x`.

    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final VulkanOffset3D.Builder setY(int y)
    Initializes the value for the `y` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `y`.

    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setZ

    public final VulkanOffset3D.Builder setZ(int z)
    Initializes the value for the `z` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `z`.

    Parameters:
      `z` - The value for z
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanOffset3D build()
    Builds a new `VulkanOffset3D`.
    Returns:
      An immutable instance of VulkanOffset3D
    Throws:
      `IllegalStateException` - if any required attributes are missing